Imports System
Imports System.Data
Imports NorthwindWinFormViewsDynamic_VB.DataLayer
Imports NorthwindWinFormViewsDynamic_VB.BusinessObject
Imports NorthwindWinFormViewsDynamic_VB.Models
Imports System.Runtime.InteropServices

Namespace BusinessObject.Base

     ''' <summary>
     ''' Base class for CustomerAndSuppliersByCity.  Do not make changes to this class,
     ''' instead, put additional code in the CustomerAndSuppliersByCity class
     ''' </summary>
     Public Class CustomerAndSuppliersByCityBase
         ' private members
         Private _city As String
         Private _companyName As String
         Private _contactName As String
         Private _relationship As String

         ''' <summary>
         ''' Gets or Sets City
         ''' </summary>
         Public Property City() As String
             Get
                 Return _city
             End Get
             Set(ByVal value As String)
                 _city = value
             End Set
         End Property

         ''' <summary>
         ''' Gets or Sets CompanyName
         ''' </summary>
         Public Property CompanyName() As String
             Get
                 Return _companyName
             End Get
             Set(ByVal value As String)
                 _companyName = value
             End Set
         End Property

         ''' <summary>
         ''' Gets or Sets ContactName
         ''' </summary>
         Public Property ContactName() As String
             Get
                 Return _contactName
             End Get
             Set(ByVal value As String)
                 _contactName = value
             End Set
         End Property

         ''' <summary>
         ''' Gets or Sets Relationship
         ''' </summary>
         Public Property Relationship() As String
             Get
                 Return _relationship
             End Get
             Set(ByVal value As String)
                 _relationship = value
             End Set
         End Property


         ''' <summary>
         ''' Constructor
         ''' </summary>
         Public Sub New()
         End Sub

         ''' <summary>
         ''' Gets the total number of records in the CustomerAndSuppliersByCity table
         ''' </summary>
         Public Shared Function GetRecordCount() As Integer
             Return CustomerAndSuppliersByCityDataLayer.GetRecordCount()
         End Function

         ''' <summary>
         ''' Selects records as a collection (List) of CustomerAndSuppliersByCity sorted by the sortByExpression and returns the rows (# of records) starting from the startRowIndex
         ''' </summary>
         Public Shared Function SelectSkipAndTake(rows As Integer, startRowIndex As Integer, <Out()> ByRef totalRowCount As Integer, sortByExpression As String) As CustomerAndSuppliersByCityCollection
             totalRowCount = GetRecordCount()
             sortByExpression = GetSortExpression(sortByExpression)

             Return CustomerAndSuppliersByCityDataLayer.SelectSkipAndTake(sortByExpression, startRowIndex, rows)
         End Function

         ''' <summary>
         ''' Selects records as a collection (List) of CustomerAndSuppliersByCity sorted by the sortByExpression and returns the rows (# of records) starting from the startRowIndex.  Use for non model-binded gridview control.  Does not return total row count.
         ''' </summary>
         Public Shared Function SelectSkipAndTake(rows As Integer, startRowIndex As Integer, sortByExpression As String) As CustomerAndSuppliersByCityCollection
             sortByExpression = GetSortExpression(sortByExpression)
             Return CustomerAndSuppliersByCityDataLayer.SelectSkipAndTake(sortByExpression, startRowIndex, rows)
         End Function

         Private Shared Function GetSortExpression(sortByExpression As String) As String
             If [String].IsNullOrEmpty(sortByExpression) Or sortByExpression = " asc" Then
                 sortByExpression = "City"
             Else If sortByExpression.Contains(" asc") Then
                 sortByExpression = sortByExpression.Replace(" asc", "")
             End If

             Return sortByExpression
         End Function

         ''' <summary>
         ''' Compares City used for sorting
         ''' </summary>
         Public Shared ByCity As Comparison(Of CustomerAndSuppliersByCity) =
         Function(ByVal x As CustomerAndSuppliersByCity, ByVal y As CustomerAndSuppliersByCity)
             Dim value1 As String = If(x.City, String.Empty)
             Dim value2 As String = If(y.City, String.Empty)
             Return value1.CompareTo(value2)
         End Function

         ''' <summary>
         ''' Compares CompanyName used for sorting
         ''' </summary>
         Public Shared ByCompanyName As Comparison(Of CustomerAndSuppliersByCity) =
         Function(ByVal x As CustomerAndSuppliersByCity, ByVal y As CustomerAndSuppliersByCity)
             Dim value1 As String = If(x.CompanyName, String.Empty)
             Dim value2 As String = If(y.CompanyName, String.Empty)
             Return value1.CompareTo(value2)
         End Function

         ''' <summary>
         ''' Compares ContactName used for sorting
         ''' </summary>
         Public Shared ByContactName As Comparison(Of CustomerAndSuppliersByCity) =
         Function(ByVal x As CustomerAndSuppliersByCity, ByVal y As CustomerAndSuppliersByCity)
             Dim value1 As String = If(x.ContactName, String.Empty)
             Dim value2 As String = If(y.ContactName, String.Empty)
             Return value1.CompareTo(value2)
         End Function

         ''' <summary>
         ''' Compares Relationship used for sorting
         ''' </summary>
         Public Shared ByRelationship As Comparison(Of CustomerAndSuppliersByCity) =
         Function(ByVal x As CustomerAndSuppliersByCity, ByVal y As CustomerAndSuppliersByCity)
             Dim value1 As String = If(x.Relationship, String.Empty)
             Dim value2 As String = If(y.Relationship, String.Empty)
             Return value1.CompareTo(value2)
         End Function

     End Class
End Namespace
