Imports System
Imports System.Data
Imports NorthwindWinFormViewsDynamic_VB.DataLayer
Imports NorthwindWinFormViewsDynamic_VB.BusinessObject
Imports NorthwindWinFormViewsDynamic_VB.Models
Imports System.Runtime.InteropServices

Namespace BusinessObject.Base

     ''' <summary>
     ''' Base class for OrdersQry.  Do not make changes to this class,
     ''' instead, put additional code in the OrdersQry class
     ''' </summary>
     Public Class OrdersQryBase
         ' private members
         Private _orderID As Integer
         Private _customerID As String
         Private _employeeID As System.Nullable(Of Integer)
         Private _orderDate As System.Nullable(Of Date)
         Private _requiredDate As System.Nullable(Of Date)
         Private _shippedDate As System.Nullable(Of Date)
         Private _shipVia As System.Nullable(Of Integer)
         Private _freight As System.Nullable(Of Decimal)
         Private _freightTotal As Decimal
         Private _shipName As String
         Private _shipAddress As String
         Private _shipCity As String
         Private _shipRegion As String
         Private _shipPostalCode As String
         Private _shipCountry As String
         Private _companyName As String
         Private _address As String
         Private _city As String
         Private _region1 As String
         Private _postalCode As String
         Private _country As String

         ''' <summary>
         ''' Gets or Sets OrderID
         ''' </summary>
         Public Property OrderID() As Integer
             Get
                 Return _orderID
             End Get
             Set(ByVal value As Integer)
                 _orderID = value
             End Set
         End Property

         ''' <summary>
         ''' Gets or Sets CustomerID
         ''' </summary>
         Public Property CustomerID() As String
             Get
                 Return _customerID
             End Get
             Set(ByVal value As String)
                 _customerID = value
             End Set
         End Property

         ''' <summary>
         ''' Gets or Sets EmployeeID
         ''' </summary>
         Public Property EmployeeID() As System.Nullable(Of Integer)
             Get
                 Return _employeeID
             End Get
             Set(ByVal value As System.Nullable(Of Integer))
                 _employeeID = value
             End Set
         End Property

         ''' <summary>
         ''' Gets or Sets OrderDate
         ''' </summary>
         Public Property OrderDate() As System.Nullable(Of Date)
             Get
                 Return _orderDate
             End Get
             Set(ByVal value As System.Nullable(Of Date))
                 _orderDate = value
             End Set
         End Property

         ''' <summary>
         ''' Gets or Sets RequiredDate
         ''' </summary>
         Public Property RequiredDate() As System.Nullable(Of Date)
             Get
                 Return _requiredDate
             End Get
             Set(ByVal value As System.Nullable(Of Date))
                 _requiredDate = value
             End Set
         End Property

         ''' <summary>
         ''' Gets or Sets ShippedDate
         ''' </summary>
         Public Property ShippedDate() As System.Nullable(Of Date)
             Get
                 Return _shippedDate
             End Get
             Set(ByVal value As System.Nullable(Of Date))
                 _shippedDate = value
             End Set
         End Property

         ''' <summary>
         ''' Gets or Sets ShipVia
         ''' </summary>
         Public Property ShipVia() As System.Nullable(Of Integer)
             Get
                 Return _shipVia
             End Get
             Set(ByVal value As System.Nullable(Of Integer))
                 _shipVia = value
             End Set
         End Property

         ''' <summary>
         ''' Gets or Sets Freight
         ''' </summary>
         Public Property Freight() As System.Nullable(Of Decimal)
             Get
                 Return _freight
             End Get
             Set(ByVal value As System.Nullable(Of Decimal))
                 _freight = value
             End Set
         End Property

         ''' <summary>
         ''' Gets or Sets FreightTotal
         ''' </summary>
         Public Property FreightTotal() As Decimal
             Get
                 Return _freightTotal
             End Get
             Set(ByVal value As Decimal)
                 _freightTotal = value
             End Set
         End Property

         ''' <summary>
         ''' Gets or Sets ShipName
         ''' </summary>
         Public Property ShipName() As String
             Get
                 Return _shipName
             End Get
             Set(ByVal value As String)
                 _shipName = value
             End Set
         End Property

         ''' <summary>
         ''' Gets or Sets ShipAddress
         ''' </summary>
         Public Property ShipAddress() As String
             Get
                 Return _shipAddress
             End Get
             Set(ByVal value As String)
                 _shipAddress = value
             End Set
         End Property

         ''' <summary>
         ''' Gets or Sets ShipCity
         ''' </summary>
         Public Property ShipCity() As String
             Get
                 Return _shipCity
             End Get
             Set(ByVal value As String)
                 _shipCity = value
             End Set
         End Property

         ''' <summary>
         ''' Gets or Sets ShipRegion
         ''' </summary>
         Public Property ShipRegion() As String
             Get
                 Return _shipRegion
             End Get
             Set(ByVal value As String)
                 _shipRegion = value
             End Set
         End Property

         ''' <summary>
         ''' Gets or Sets ShipPostalCode
         ''' </summary>
         Public Property ShipPostalCode() As String
             Get
                 Return _shipPostalCode
             End Get
             Set(ByVal value As String)
                 _shipPostalCode = value
             End Set
         End Property

         ''' <summary>
         ''' Gets or Sets ShipCountry
         ''' </summary>
         Public Property ShipCountry() As String
             Get
                 Return _shipCountry
             End Get
             Set(ByVal value As String)
                 _shipCountry = value
             End Set
         End Property

         ''' <summary>
         ''' Gets or Sets CompanyName
         ''' </summary>
         Public Property CompanyName() As String
             Get
                 Return _companyName
             End Get
             Set(ByVal value As String)
                 _companyName = value
             End Set
         End Property

         ''' <summary>
         ''' Gets or Sets Address
         ''' </summary>
         Public Property Address() As String
             Get
                 Return _address
             End Get
             Set(ByVal value As String)
                 _address = value
             End Set
         End Property

         ''' <summary>
         ''' Gets or Sets City
         ''' </summary>
         Public Property City() As String
             Get
                 Return _city
             End Get
             Set(ByVal value As String)
                 _city = value
             End Set
         End Property

         ''' <summary>
         ''' Gets or Sets Region1
         ''' </summary>
         Public Property Region1() As String
             Get
                 Return _region1
             End Get
             Set(ByVal value As String)
                 _region1 = value
             End Set
         End Property

         ''' <summary>
         ''' Gets or Sets PostalCode
         ''' </summary>
         Public Property PostalCode() As String
             Get
                 Return _postalCode
             End Get
             Set(ByVal value As String)
                 _postalCode = value
             End Set
         End Property

         ''' <summary>
         ''' Gets or Sets Country
         ''' </summary>
         Public Property Country() As String
             Get
                 Return _country
             End Get
             Set(ByVal value As String)
                 _country = value
             End Set
         End Property


         ''' <summary>
         ''' Constructor
         ''' </summary>
         Public Sub New()
         End Sub

         ''' <summary>
         ''' Gets the total number of records in the OrdersQry table
         ''' </summary>
         Public Shared Function GetRecordCount() As Integer
             Return OrdersQryDataLayer.GetRecordCount()
         End Function

         ''' <summary>
         ''' Selects records as a collection (List) of OrdersQry sorted by the sortByExpression and returns the rows (# of records) starting from the startRowIndex
         ''' </summary>
         Public Shared Function SelectSkipAndTake(rows As Integer, startRowIndex As Integer, <Out()> ByRef totalRowCount As Integer, sortByExpression As String) As OrdersQryCollection
             totalRowCount = GetRecordCount()
             sortByExpression = GetSortExpression(sortByExpression)

             Return OrdersQryDataLayer.SelectSkipAndTake(sortByExpression, startRowIndex, rows)
         End Function

         ''' <summary>
         ''' Selects records as a collection (List) of OrdersQry sorted by the sortByExpression and returns the rows (# of records) starting from the startRowIndex.  Use for non model-binded gridview control.  Does not return total row count.
         ''' </summary>
         Public Shared Function SelectSkipAndTake(rows As Integer, startRowIndex As Integer, sortByExpression As String) As OrdersQryCollection
             sortByExpression = GetSortExpression(sortByExpression)
             Return OrdersQryDataLayer.SelectSkipAndTake(sortByExpression, startRowIndex, rows)
         End Function

         Private Shared Function GetSortExpression(sortByExpression As String) As String
             If [String].IsNullOrEmpty(sortByExpression) Or sortByExpression = " asc" Then
                 sortByExpression = "OrderID"
             Else If sortByExpression.Contains(" asc") Then
                 sortByExpression = sortByExpression.Replace(" asc", "")
             End If

             Return sortByExpression
         End Function

         ''' <summary>
         ''' Compares OrderID used for sorting
         ''' </summary>
         Public Shared ByOrderID As Comparison(Of OrdersQry) =
         Function(ByVal x As OrdersQry, ByVal y As OrdersQry)
             Return x.OrderID.CompareTo(y.OrderID)
         End Function

         ''' <summary>
         ''' Compares CustomerID used for sorting
         ''' </summary>
         Public Shared ByCustomerID As Comparison(Of OrdersQry) =
         Function(ByVal x As OrdersQry, ByVal y As OrdersQry)
             Dim value1 As String = If(x.CustomerID, String.Empty)
             Dim value2 As String = If(y.CustomerID, String.Empty)
             Return value1.CompareTo(value2)
         End Function

         ''' <summary>
         ''' Compares EmployeeID used for sorting
         ''' </summary>
         Public Shared ByEmployeeID As Comparison(Of OrdersQry) =
         Function(ByVal x As OrdersQry, ByVal y As OrdersQry)
             Return Nullable.Compare(x.EmployeeID, y.EmployeeID)
         End Function

         ''' <summary>
         ''' Compares OrderDate used for sorting
         ''' </summary>
         Public Shared ByOrderDate As Comparison(Of OrdersQry) =
         Function(ByVal x As OrdersQry, ByVal y As OrdersQry)
             Return Nullable.Compare(x.OrderDate, y.OrderDate)
         End Function

         ''' <summary>
         ''' Compares RequiredDate used for sorting
         ''' </summary>
         Public Shared ByRequiredDate As Comparison(Of OrdersQry) =
         Function(ByVal x As OrdersQry, ByVal y As OrdersQry)
             Return Nullable.Compare(x.RequiredDate, y.RequiredDate)
         End Function

         ''' <summary>
         ''' Compares ShippedDate used for sorting
         ''' </summary>
         Public Shared ByShippedDate As Comparison(Of OrdersQry) =
         Function(ByVal x As OrdersQry, ByVal y As OrdersQry)
             Return Nullable.Compare(x.ShippedDate, y.ShippedDate)
         End Function

         ''' <summary>
         ''' Compares ShipVia used for sorting
         ''' </summary>
         Public Shared ByShipVia As Comparison(Of OrdersQry) =
         Function(ByVal x As OrdersQry, ByVal y As OrdersQry)
             Return Nullable.Compare(x.ShipVia, y.ShipVia)
         End Function

         ''' <summary>
         ''' Compares Freight used for sorting
         ''' </summary>
         Public Shared ByFreight As Comparison(Of OrdersQry) =
         Function(ByVal x As OrdersQry, ByVal y As OrdersQry)
             Return Nullable.Compare(x.Freight, y.Freight)
         End Function

         ''' <summary>
         ''' Compares ShipName used for sorting
         ''' </summary>
         Public Shared ByShipName As Comparison(Of OrdersQry) =
         Function(ByVal x As OrdersQry, ByVal y As OrdersQry)
             Dim value1 As String = If(x.ShipName, String.Empty)
             Dim value2 As String = If(y.ShipName, String.Empty)
             Return value1.CompareTo(value2)
         End Function

         ''' <summary>
         ''' Compares ShipAddress used for sorting
         ''' </summary>
         Public Shared ByShipAddress As Comparison(Of OrdersQry) =
         Function(ByVal x As OrdersQry, ByVal y As OrdersQry)
             Dim value1 As String = If(x.ShipAddress, String.Empty)
             Dim value2 As String = If(y.ShipAddress, String.Empty)
             Return value1.CompareTo(value2)
         End Function

         ''' <summary>
         ''' Compares ShipCity used for sorting
         ''' </summary>
         Public Shared ByShipCity As Comparison(Of OrdersQry) =
         Function(ByVal x As OrdersQry, ByVal y As OrdersQry)
             Dim value1 As String = If(x.ShipCity, String.Empty)
             Dim value2 As String = If(y.ShipCity, String.Empty)
             Return value1.CompareTo(value2)
         End Function

         ''' <summary>
         ''' Compares ShipRegion used for sorting
         ''' </summary>
         Public Shared ByShipRegion As Comparison(Of OrdersQry) =
         Function(ByVal x As OrdersQry, ByVal y As OrdersQry)
             Dim value1 As String = If(x.ShipRegion, String.Empty)
             Dim value2 As String = If(y.ShipRegion, String.Empty)
             Return value1.CompareTo(value2)
         End Function

         ''' <summary>
         ''' Compares ShipPostalCode used for sorting
         ''' </summary>
         Public Shared ByShipPostalCode As Comparison(Of OrdersQry) =
         Function(ByVal x As OrdersQry, ByVal y As OrdersQry)
             Dim value1 As String = If(x.ShipPostalCode, String.Empty)
             Dim value2 As String = If(y.ShipPostalCode, String.Empty)
             Return value1.CompareTo(value2)
         End Function

         ''' <summary>
         ''' Compares ShipCountry used for sorting
         ''' </summary>
         Public Shared ByShipCountry As Comparison(Of OrdersQry) =
         Function(ByVal x As OrdersQry, ByVal y As OrdersQry)
             Dim value1 As String = If(x.ShipCountry, String.Empty)
             Dim value2 As String = If(y.ShipCountry, String.Empty)
             Return value1.CompareTo(value2)
         End Function

         ''' <summary>
         ''' Compares CompanyName used for sorting
         ''' </summary>
         Public Shared ByCompanyName As Comparison(Of OrdersQry) =
         Function(ByVal x As OrdersQry, ByVal y As OrdersQry)
             Dim value1 As String = If(x.CompanyName, String.Empty)
             Dim value2 As String = If(y.CompanyName, String.Empty)
             Return value1.CompareTo(value2)
         End Function

         ''' <summary>
         ''' Compares Address used for sorting
         ''' </summary>
         Public Shared ByAddress As Comparison(Of OrdersQry) =
         Function(ByVal x As OrdersQry, ByVal y As OrdersQry)
             Dim value1 As String = If(x.Address, String.Empty)
             Dim value2 As String = If(y.Address, String.Empty)
             Return value1.CompareTo(value2)
         End Function

         ''' <summary>
         ''' Compares City used for sorting
         ''' </summary>
         Public Shared ByCity As Comparison(Of OrdersQry) =
         Function(ByVal x As OrdersQry, ByVal y As OrdersQry)
             Dim value1 As String = If(x.City, String.Empty)
             Dim value2 As String = If(y.City, String.Empty)
             Return value1.CompareTo(value2)
         End Function

         ''' <summary>
         ''' Compares Region1 used for sorting
         ''' </summary>
         Public Shared ByRegion1 As Comparison(Of OrdersQry) =
         Function(ByVal x As OrdersQry, ByVal y As OrdersQry)
             Dim value1 As String = If(x.Region1, String.Empty)
             Dim value2 As String = If(y.Region1, String.Empty)
             Return value1.CompareTo(value2)
         End Function

         ''' <summary>
         ''' Compares PostalCode used for sorting
         ''' </summary>
         Public Shared ByPostalCode As Comparison(Of OrdersQry) =
         Function(ByVal x As OrdersQry, ByVal y As OrdersQry)
             Dim value1 As String = If(x.PostalCode, String.Empty)
             Dim value2 As String = If(y.PostalCode, String.Empty)
             Return value1.CompareTo(value2)
         End Function

         ''' <summary>
         ''' Compares Country used for sorting
         ''' </summary>
         Public Shared ByCountry As Comparison(Of OrdersQry) =
         Function(ByVal x As OrdersQry, ByVal y As OrdersQry)
             Dim value1 As String = If(x.Country, String.Empty)
             Dim value2 As String = If(y.Country, String.Empty)
             Return value1.CompareTo(value2)
         End Function

     End Class
End Namespace
