Imports System
Imports System.Data
Imports NorthwindWinFormViewsDynamic_VB.DataLayer
Imports NorthwindWinFormViewsDynamic_VB.BusinessObject
Imports NorthwindWinFormViewsDynamic_VB.Models
Imports System.Runtime.InteropServices

Namespace BusinessObject.Base

     ''' <summary>
     ''' Base class for SummaryOfSalesByYear.  Do not make changes to this class,
     ''' instead, put additional code in the SummaryOfSalesByYear class
     ''' </summary>
     Public Class SummaryOfSalesByYearBase
         ' private members
         Private _shippedDate As System.Nullable(Of Date)
         Private _orderID As Integer
         Private _subtotal As System.Nullable(Of Decimal)
         Private _subtotalTotal As Decimal

         ''' <summary>
         ''' Gets or Sets ShippedDate
         ''' </summary>
         Public Property ShippedDate() As System.Nullable(Of Date)
             Get
                 Return _shippedDate
             End Get
             Set(ByVal value As System.Nullable(Of Date))
                 _shippedDate = value
             End Set
         End Property

         ''' <summary>
         ''' Gets or Sets OrderID
         ''' </summary>
         Public Property OrderID() As Integer
             Get
                 Return _orderID
             End Get
             Set(ByVal value As Integer)
                 _orderID = value
             End Set
         End Property

         ''' <summary>
         ''' Gets or Sets Subtotal
         ''' </summary>
         Public Property Subtotal() As System.Nullable(Of Decimal)
             Get
                 Return _subtotal
             End Get
             Set(ByVal value As System.Nullable(Of Decimal))
                 _subtotal = value
             End Set
         End Property

         ''' <summary>
         ''' Gets or Sets SubtotalTotal
         ''' </summary>
         Public Property SubtotalTotal() As Decimal
             Get
                 Return _subtotalTotal
             End Get
             Set(ByVal value As Decimal)
                 _subtotalTotal = value
             End Set
         End Property


         ''' <summary>
         ''' Constructor
         ''' </summary>
         Public Sub New()
         End Sub

         ''' <summary>
         ''' Gets the total number of records in the SummaryOfSalesByYear table
         ''' </summary>
         Public Shared Function GetRecordCount() As Integer
             Return SummaryOfSalesByYearDataLayer.GetRecordCount()
         End Function

         ''' <summary>
         ''' Selects records as a collection (List) of SummaryOfSalesByYear sorted by the sortByExpression and returns the rows (# of records) starting from the startRowIndex
         ''' </summary>
         Public Shared Function SelectSkipAndTake(rows As Integer, startRowIndex As Integer, <Out()> ByRef totalRowCount As Integer, sortByExpression As String) As SummaryOfSalesByYearCollection
             totalRowCount = GetRecordCount()
             sortByExpression = GetSortExpression(sortByExpression)

             Return SummaryOfSalesByYearDataLayer.SelectSkipAndTake(sortByExpression, startRowIndex, rows)
         End Function

         ''' <summary>
         ''' Selects records as a collection (List) of SummaryOfSalesByYear sorted by the sortByExpression and returns the rows (# of records) starting from the startRowIndex.  Use for non model-binded gridview control.  Does not return total row count.
         ''' </summary>
         Public Shared Function SelectSkipAndTake(rows As Integer, startRowIndex As Integer, sortByExpression As String) As SummaryOfSalesByYearCollection
             sortByExpression = GetSortExpression(sortByExpression)
             Return SummaryOfSalesByYearDataLayer.SelectSkipAndTake(sortByExpression, startRowIndex, rows)
         End Function

         Private Shared Function GetSortExpression(sortByExpression As String) As String
             If [String].IsNullOrEmpty(sortByExpression) Or sortByExpression = " asc" Then
                 sortByExpression = "ShippedDate"
             Else If sortByExpression.Contains(" asc") Then
                 sortByExpression = sortByExpression.Replace(" asc", "")
             End If

             Return sortByExpression
         End Function

         ''' <summary>
         ''' Compares ShippedDate used for sorting
         ''' </summary>
         Public Shared ByShippedDate As Comparison(Of SummaryOfSalesByYear) =
         Function(ByVal x As SummaryOfSalesByYear, ByVal y As SummaryOfSalesByYear)
             Return Nullable.Compare(x.ShippedDate, y.ShippedDate)
         End Function

         ''' <summary>
         ''' Compares OrderID used for sorting
         ''' </summary>
         Public Shared ByOrderID As Comparison(Of SummaryOfSalesByYear) =
         Function(ByVal x As SummaryOfSalesByYear, ByVal y As SummaryOfSalesByYear)
             Return x.OrderID.CompareTo(y.OrderID)
         End Function

         ''' <summary>
         ''' Compares Subtotal used for sorting
         ''' </summary>
         Public Shared BySubtotal As Comparison(Of SummaryOfSalesByYear) =
         Function(ByVal x As SummaryOfSalesByYear, ByVal y As SummaryOfSalesByYear)
             Return Nullable.Compare(x.Subtotal, y.Subtotal)
         End Function

     End Class
End Namespace
