Imports System
Imports System.Data
Imports System.Data.SqlClient
Imports System.Configuration
Imports NorthwindWinFormViewsDynamic_VB.BusinessObject

Namespace DataLayer.Base
     ''' <summary>
     ''' Base class for SalesTotalsByAmountDataLayer.  Do not make changes to this class,
     ''' instead, put additional code in the SalesTotalsByAmountDataLayer class
     ''' </summary>
     Public Class SalesTotalsByAmountDataLayerBase

         ' constructor
         Public Sub New()
         End Sub

         Public Shared Function SelectShared(dynamicSqlScript As String, param As String, paramValue As Object, Optional ByVal sortByExpression As String = Nothing, Optional ByVal startRowIndex As Integer? = Nothing, Optional ByVal rows As Integer? = Nothing) As SalesTotalsByAmountCollection
              Dim objSalesTotalsByAmountCol As SalesTotalsByAmountCollection = Nothing

              Using connection As New SqlConnection(ConfigurationManager.ConnectionStrings("ConnectionString").ConnectionString)
                  connection.Open()

                  Using command As New SqlCommand(dynamicSqlScript, connection)
                      command.CommandType = CommandType.Text

                      ' select, skip, take, sort parameters
                      If Not [String].IsNullOrEmpty(sortByExpression) AndAlso startRowIndex IsNot Nothing AndAlso rows IsNot Nothing Then
                          command.Parameters.AddWithValue("@start", startRowIndex.Value)
                          command.Parameters.AddWithValue("@numberOfRows", rows.Value)
                          command.Parameters.AddWithValue("@sortByExpression", sortByExpression)
                      End If

                      Using da As New SqlDataAdapter(command)
                          Dim dt As New DataTable()
                          da.Fill(dt)

                          If dt IsNot Nothing Then
                              If dt.Rows.Count > 0 Then
                                  objSalesTotalsByAmountCol = New SalesTotalsByAmountCollection()

                                  For Each dr As DataRow In dt.Rows
                                      Dim objSalesTotalsByAmount As SalesTotalsByAmount = CreateSalesTotalsByAmountFromDataRowShared(dr)
                                      objSalesTotalsByAmountCol.Add(objSalesTotalsByAmount)
                                  Next
                              End If
                          End If
                      End Using
                  End Using
              End Using

              Return objSalesTotalsByAmountCol
         End Function

         ''' <summary>
         ''' Gets the total number of records in the SalesTotalsByAmount table
         ''' </summary>
         Public Shared Function GetRecordCount() As Integer
             Dim sql As String = SalesTotalsByAmountSql.GetRecordCount()
             Return GetRecordCountShared(Nothing, Nothing, Nothing, False, sql)
         End Function

         Public Shared Function GetRecordCountShared(Optional ByVal storedProcName As String = Nothing, Optional ByVal param As String = Nothing, Optional ByVal paramValue As Object = Nothing, Optional ByVal isUseStoredProc As Boolean = True, Optional ByVal dynamicSqlScript As String = Nothing) As Integer
              Dim recordCount As Integer = 0

              Using connection As New SqlConnection(ConfigurationManager.ConnectionStrings("ConnectionString").ConnectionString)
                  connection.Open()

                  Using command As New SqlCommand(dynamicSqlScript, connection)
                      command.CommandType = CommandType.Text

                      Using da As New SqlDataAdapter(command)
                          Dim dt As New DataTable()
                          da.Fill(dt)

                          If dt IsNot Nothing Then
                              If dt.Rows.Count > 0 Then
                                  recordCount = DirectCast(dt.Rows(0)("RecordCount"), Integer)
                              End If
                          End If
                      End Using
                  End Using
              End Using

              Return recordCount
         End Function

         ''' <summary>
         ''' Selects SalesTotalsByAmount records sorted by the sortByExpression and returns records from the startRowIndex with rows (# of records)
         ''' </summary>
         Public Shared Function SelectSkipAndTake(sortByExpression As String, startRowIndex As Integer, rows As Integer) As SalesTotalsByAmountCollection
             Dim dynamicSqlScript As String = SalesTotalsByAmountSql.SelectSkipAndTake()
             Return SelectShared(dynamicSqlScript, Nothing, Nothing, sortByExpression, startRowIndex, rows)
         End Function

         ''' <summary>
         ''' Creates a SalesTotalsByAmount object from the passed data row
         ''' </summary>
         Private Shared Function CreateSalesTotalsByAmountFromDataRowShared(dr As DataRow) As SalesTotalsByAmount
             Dim objSalesTotalsByAmount As SalesTotalsByAmount = New SalesTotalsByAmount()


             If Not DbNull.Value.Equals(dr("SaleAmount")) Then
                 objSalesTotalsByAmount.SaleAmount = DirectCast(dr("SaleAmount"), Decimal)
             Else
                 objSalesTotalsByAmount.SaleAmount = Nothing
             End If

             If Not DbNull.Value.Equals(dr("OrderID")) Then
                 objSalesTotalsByAmount.OrderID = DirectCast(dr("OrderID"), Integer)
             Else
                 objSalesTotalsByAmount.OrderID = Nothing
             End If

             If Not DbNull.Value.Equals(dr("CompanyName")) Then
                 objSalesTotalsByAmount.CompanyName = dr("CompanyName").ToString()
             Else
                 objSalesTotalsByAmount.CompanyName = Nothing
             End If

             If Not DbNull.Value.Equals(dr("ShippedDate")) Then
                 objSalesTotalsByAmount.ShippedDate = DirectCast(dr("ShippedDate"), Date)
             Else
                 objSalesTotalsByAmount.ShippedDate = Nothing
             End If

             Return objSalesTotalsByAmount
         End Function
     End Class
End Namespace
