Imports System 
Imports System.Text 

Namespace DataLayer.Base
    Public NotInheritable Class AlphabeticalListOfProductsSql
        Private Sub New() 
        End Sub 

        Public Shared Function GetRecordCount() As String 
            Dim sb As New StringBuilder() 

            sb.Append("SELECT COUNT(*) AS RecordCount FROM [dbo].[Alphabetical list of products]")

            Return sb.ToString() 
        End Function 

        Public Shared Function SelectSkipAndTake() As String 
            Dim selectStatement As String = GetSelectStatement() 
            Dim sb As New StringBuilder() 

            sb.Append("DECLARE @numberOfRowsToSkip int = @start - 1; ")

            sb.Append("SELECT ")
            sb.Append("[ProductID], ")
            sb.Append("[ProductName], ")
            sb.Append("[SupplierID], ")
            sb.Append("[CategoryID], ")
            sb.Append("[QuantityPerUnit], ")
            sb.Append("[UnitPrice], ")
            sb.Append("[UnitsInStock], ")
            sb.Append("[UnitsOnOrder], ")
            sb.Append("[ReorderLevel], ")
            sb.Append("[Discontinued], ")
            sb.Append("[CategoryName] ")
            sb.Append("FROM [dbo].[Alphabetical list of products] ")
            sb.Append("ORDER BY ")
	        sb.Append("CASE WHEN @sortByExpression = 'ProductID' THEN [ProductID] END, ")
	        sb.Append("CASE WHEN @sortByExpression = 'ProductID desc' THEN [ProductID] END DESC, ")

	        sb.Append("CASE WHEN @sortByExpression = 'ProductName' THEN [ProductName] END, ")
	        sb.Append("CASE WHEN @sortByExpression = 'ProductName desc' THEN [ProductName] END DESC, ")

	        sb.Append("CASE WHEN @sortByExpression = 'SupplierID' THEN [SupplierID] END, ")
	        sb.Append("CASE WHEN @sortByExpression = 'SupplierID desc' THEN [SupplierID] END DESC, ")

	        sb.Append("CASE WHEN @sortByExpression = 'CategoryID' THEN [CategoryID] END, ")
	        sb.Append("CASE WHEN @sortByExpression = 'CategoryID desc' THEN [CategoryID] END DESC, ")

	        sb.Append("CASE WHEN @sortByExpression = 'QuantityPerUnit' THEN [QuantityPerUnit] END, ")
	        sb.Append("CASE WHEN @sortByExpression = 'QuantityPerUnit desc' THEN [QuantityPerUnit] END DESC, ")

	        sb.Append("CASE WHEN @sortByExpression = 'UnitPrice' THEN [UnitPrice] END, ")
	        sb.Append("CASE WHEN @sortByExpression = 'UnitPrice desc' THEN [UnitPrice] END DESC, ")

	        sb.Append("CASE WHEN @sortByExpression = 'UnitsInStock' THEN [UnitsInStock] END, ")
	        sb.Append("CASE WHEN @sortByExpression = 'UnitsInStock desc' THEN [UnitsInStock] END DESC, ")

	        sb.Append("CASE WHEN @sortByExpression = 'UnitsOnOrder' THEN [UnitsOnOrder] END, ")
	        sb.Append("CASE WHEN @sortByExpression = 'UnitsOnOrder desc' THEN [UnitsOnOrder] END DESC, ")

	        sb.Append("CASE WHEN @sortByExpression = 'ReorderLevel' THEN [ReorderLevel] END, ")
	        sb.Append("CASE WHEN @sortByExpression = 'ReorderLevel desc' THEN [ReorderLevel] END DESC, ")

	        sb.Append("CASE WHEN @sortByExpression = 'Discontinued' THEN [Discontinued] END, ")
	        sb.Append("CASE WHEN @sortByExpression = 'Discontinued desc' THEN [Discontinued] END DESC, ")

	        sb.Append("CASE WHEN @sortByExpression = 'CategoryName' THEN [CategoryName] END, ")
	        sb.Append("CASE WHEN @sortByExpression = 'CategoryName desc' THEN [CategoryName] END DESC ")

            sb.Append("OFFSET @numberOfRowsToSkip ROWS ")
            sb.Append("FETCH NEXT @numberOfRows ROWS ONLY ")

            Return sb.ToString() 
        End Function 

        Public Shared Function GetSelectStatement() As String 
            Dim sb As New StringBuilder() 

            sb.Append("SELECT ") 
            sb.Append("[ProductID], ") 
            sb.Append("[ProductName], ") 
            sb.Append("[SupplierID], ") 
            sb.Append("[CategoryID], ") 
            sb.Append("[QuantityPerUnit], ") 
            sb.Append("[UnitPrice], ") 
            sb.Append("[UnitsInStock], ") 
            sb.Append("[UnitsOnOrder], ") 
            sb.Append("[ReorderLevel], ") 
            sb.Append("[Discontinued], ") 
            sb.Append("[CategoryName] ") 
            sb.Append("FROM [dbo].[Alphabetical list of products] ") 

            Return sb.ToString() 
        End Function 
    End Class 
End Namespace 
