Imports System 
Imports System.Text 

Namespace DataLayer.Base
    Public NotInheritable Class CustomerAndSuppliersByCitySql
        Private Sub New() 
        End Sub 

        Public Shared Function GetRecordCount() As String 
            Dim sb As New StringBuilder() 

            sb.Append("SELECT COUNT(*) AS RecordCount FROM [dbo].[Customer and Suppliers by City]")

            Return sb.ToString() 
        End Function 

        Public Shared Function SelectSkipAndTake() As String 
            Dim selectStatement As String = GetSelectStatement() 
            Dim sb As New StringBuilder() 

            sb.Append("DECLARE @numberOfRowsToSkip int = @start - 1; ")

            sb.Append("SELECT ")
            sb.Append("[City], ")
            sb.Append("[CompanyName], ")
            sb.Append("[ContactName], ")
            sb.Append("[Relationship] ")
            sb.Append("FROM [dbo].[Customer and Suppliers by City] ")
            sb.Append("ORDER BY ")
	        sb.Append("CASE WHEN @sortByExpression = 'City' THEN [City] END, ")
	        sb.Append("CASE WHEN @sortByExpression = 'City desc' THEN [City] END DESC, ")

	        sb.Append("CASE WHEN @sortByExpression = 'CompanyName' THEN [CompanyName] END, ")
	        sb.Append("CASE WHEN @sortByExpression = 'CompanyName desc' THEN [CompanyName] END DESC, ")

	        sb.Append("CASE WHEN @sortByExpression = 'ContactName' THEN [ContactName] END, ")
	        sb.Append("CASE WHEN @sortByExpression = 'ContactName desc' THEN [ContactName] END DESC, ")

	        sb.Append("CASE WHEN @sortByExpression = 'Relationship' THEN [Relationship] END, ")
	        sb.Append("CASE WHEN @sortByExpression = 'Relationship desc' THEN [Relationship] END DESC ")

            sb.Append("OFFSET @numberOfRowsToSkip ROWS ")
            sb.Append("FETCH NEXT @numberOfRows ROWS ONLY ")

            Return sb.ToString() 
        End Function 

        Public Shared Function GetSelectStatement() As String 
            Dim sb As New StringBuilder() 

            sb.Append("SELECT ") 
            sb.Append("[City], ") 
            sb.Append("[CompanyName], ") 
            sb.Append("[ContactName], ") 
            sb.Append("[Relationship] ") 
            sb.Append("FROM [dbo].[Customer and Suppliers by City] ") 

            Return sb.ToString() 
        End Function 
    End Class 
End Namespace 
