Imports System 
Imports System.Text 

Namespace DataLayer.Base
    Public NotInheritable Class ProductsAboveAveragePriceSql
        Private Sub New() 
        End Sub 

        Public Shared Function GetRecordCount() As String 
            Dim sb As New StringBuilder() 

            sb.Append("SELECT COUNT(*) AS RecordCount FROM [dbo].[Products Above Average Price]")

            Return sb.ToString() 
        End Function 

        Public Shared Function SelectSkipAndTake() As String 
            Dim selectStatement As String = GetSelectStatement() 
            Dim sb As New StringBuilder() 

            sb.Append("DECLARE @numberOfRowsToSkip int = @start - 1; ")

            sb.Append("SELECT ")
            sb.Append("[ProductName], ")
            sb.Append("[UnitPrice] ")
            sb.Append("FROM [dbo].[Products Above Average Price] ")
            sb.Append("ORDER BY ")
	        sb.Append("CASE WHEN @sortByExpression = 'ProductName' THEN [ProductName] END, ")
	        sb.Append("CASE WHEN @sortByExpression = 'ProductName desc' THEN [ProductName] END DESC, ")

	        sb.Append("CASE WHEN @sortByExpression = 'UnitPrice' THEN [UnitPrice] END, ")
	        sb.Append("CASE WHEN @sortByExpression = 'UnitPrice desc' THEN [UnitPrice] END DESC ")

            sb.Append("OFFSET @numberOfRowsToSkip ROWS ")
            sb.Append("FETCH NEXT @numberOfRows ROWS ONLY ")

            Return sb.ToString() 
        End Function 

        Public Shared Function GetSelectStatement() As String 
            Dim sb As New StringBuilder() 

            sb.Append("SELECT ") 
            sb.Append("[ProductName], ") 
            sb.Append("[UnitPrice] ") 
            sb.Append("FROM [dbo].[Products Above Average Price] ") 

            Return sb.ToString() 
        End Function 
    End Class 
End Namespace 
