Imports System 
Imports System.Text 

Namespace DataLayer.Base
    Public NotInheritable Class ProductsByCategorySql
        Private Sub New() 
        End Sub 

        Public Shared Function GetRecordCount() As String 
            Dim sb As New StringBuilder() 

            sb.Append("SELECT COUNT(*) AS RecordCount FROM [dbo].[Products by Category]")

            Return sb.ToString() 
        End Function 

        Public Shared Function SelectSkipAndTake() As String 
            Dim selectStatement As String = GetSelectStatement() 
            Dim sb As New StringBuilder() 

            sb.Append("DECLARE @numberOfRowsToSkip int = @start - 1; ")

            sb.Append("SELECT ")
            sb.Append("[CategoryName], ")
            sb.Append("[ProductName], ")
            sb.Append("[QuantityPerUnit], ")
            sb.Append("[UnitsInStock], ")
            sb.Append("[Discontinued] ")
            sb.Append("FROM [dbo].[Products by Category] ")
            sb.Append("ORDER BY ")
	        sb.Append("CASE WHEN @sortByExpression = 'CategoryName' THEN [CategoryName] END, ")
	        sb.Append("CASE WHEN @sortByExpression = 'CategoryName desc' THEN [CategoryName] END DESC, ")

	        sb.Append("CASE WHEN @sortByExpression = 'ProductName' THEN [ProductName] END, ")
	        sb.Append("CASE WHEN @sortByExpression = 'ProductName desc' THEN [ProductName] END DESC, ")

	        sb.Append("CASE WHEN @sortByExpression = 'QuantityPerUnit' THEN [QuantityPerUnit] END, ")
	        sb.Append("CASE WHEN @sortByExpression = 'QuantityPerUnit desc' THEN [QuantityPerUnit] END DESC, ")

	        sb.Append("CASE WHEN @sortByExpression = 'UnitsInStock' THEN [UnitsInStock] END, ")
	        sb.Append("CASE WHEN @sortByExpression = 'UnitsInStock desc' THEN [UnitsInStock] END DESC, ")

	        sb.Append("CASE WHEN @sortByExpression = 'Discontinued' THEN [Discontinued] END, ")
	        sb.Append("CASE WHEN @sortByExpression = 'Discontinued desc' THEN [Discontinued] END DESC ")

            sb.Append("OFFSET @numberOfRowsToSkip ROWS ")
            sb.Append("FETCH NEXT @numberOfRows ROWS ONLY ")

            Return sb.ToString() 
        End Function 

        Public Shared Function GetSelectStatement() As String 
            Dim sb As New StringBuilder() 

            sb.Append("SELECT ") 
            sb.Append("[CategoryName], ") 
            sb.Append("[ProductName], ") 
            sb.Append("[QuantityPerUnit], ") 
            sb.Append("[UnitsInStock], ") 
            sb.Append("[Discontinued] ") 
            sb.Append("FROM [dbo].[Products by Category] ") 

            Return sb.ToString() 
        End Function 
    End Class 
End Namespace 
