Imports System 
Imports System.Text 

Namespace DataLayer.Base
    Public NotInheritable Class QuarterlyOrdersSql
        Private Sub New() 
        End Sub 

        Public Shared Function GetRecordCount() As String 
            Dim sb As New StringBuilder() 

            sb.Append("SELECT COUNT(*) AS RecordCount FROM [dbo].[Quarterly Orders]")

            Return sb.ToString() 
        End Function 

        Public Shared Function SelectSkipAndTake() As String 
            Dim selectStatement As String = GetSelectStatement() 
            Dim sb As New StringBuilder() 

            sb.Append("DECLARE @numberOfRowsToSkip int = @start - 1; ")

            sb.Append("SELECT ")
            sb.Append("[CustomerID], ")
            sb.Append("[CompanyName], ")
            sb.Append("[City], ")
            sb.Append("[Country] ")
            sb.Append("FROM [dbo].[Quarterly Orders] ")
            sb.Append("ORDER BY ")
	        sb.Append("CASE WHEN @sortByExpression = 'CustomerID' THEN [CustomerID] END, ")
	        sb.Append("CASE WHEN @sortByExpression = 'CustomerID desc' THEN [CustomerID] END DESC, ")

	        sb.Append("CASE WHEN @sortByExpression = 'CompanyName' THEN [CompanyName] END, ")
	        sb.Append("CASE WHEN @sortByExpression = 'CompanyName desc' THEN [CompanyName] END DESC, ")

	        sb.Append("CASE WHEN @sortByExpression = 'City' THEN [City] END, ")
	        sb.Append("CASE WHEN @sortByExpression = 'City desc' THEN [City] END DESC, ")

	        sb.Append("CASE WHEN @sortByExpression = 'Country' THEN [Country] END, ")
	        sb.Append("CASE WHEN @sortByExpression = 'Country desc' THEN [Country] END DESC ")

            sb.Append("OFFSET @numberOfRowsToSkip ROWS ")
            sb.Append("FETCH NEXT @numberOfRows ROWS ONLY ")

            Return sb.ToString() 
        End Function 

        Public Shared Function GetSelectStatement() As String 
            Dim sb As New StringBuilder() 

            sb.Append("SELECT ") 
            sb.Append("[CustomerID], ") 
            sb.Append("[CompanyName], ") 
            sb.Append("[City], ") 
            sb.Append("[Country] ") 
            sb.Append("FROM [dbo].[Quarterly Orders] ") 

            Return sb.ToString() 
        End Function 
    End Class 
End Namespace 
