Imports System 
Imports System.Text 

Namespace DataLayer.Base
    Public NotInheritable Class SalesTotalsByAmountSql
        Private Sub New() 
        End Sub 

        Public Shared Function GetRecordCount() As String 
            Dim sb As New StringBuilder() 

            sb.Append("SELECT COUNT(*) AS RecordCount FROM [dbo].[Sales Totals by Amount]")

            Return sb.ToString() 
        End Function 

        Public Shared Function SelectSkipAndTake() As String 
            Dim selectStatement As String = GetSelectStatement() 
            Dim sb As New StringBuilder() 

            sb.Append("DECLARE @numberOfRowsToSkip int = @start - 1; ")

            sb.Append("SELECT ")
            sb.Append("[SaleAmount], ")
            sb.Append("[OrderID], ")
            sb.Append("[CompanyName], ")
            sb.Append("[ShippedDate] ")
            sb.Append("FROM [dbo].[Sales Totals by Amount] ")
            sb.Append("ORDER BY ")
	        sb.Append("CASE WHEN @sortByExpression = 'SaleAmount' THEN [SaleAmount] END, ")
	        sb.Append("CASE WHEN @sortByExpression = 'SaleAmount desc' THEN [SaleAmount] END DESC, ")

	        sb.Append("CASE WHEN @sortByExpression = 'OrderID' THEN [OrderID] END, ")
	        sb.Append("CASE WHEN @sortByExpression = 'OrderID desc' THEN [OrderID] END DESC, ")

	        sb.Append("CASE WHEN @sortByExpression = 'CompanyName' THEN [CompanyName] END, ")
	        sb.Append("CASE WHEN @sortByExpression = 'CompanyName desc' THEN [CompanyName] END DESC, ")

	        sb.Append("CASE WHEN @sortByExpression = 'ShippedDate' THEN [ShippedDate] END, ")
	        sb.Append("CASE WHEN @sortByExpression = 'ShippedDate desc' THEN [ShippedDate] END DESC ")

            sb.Append("OFFSET @numberOfRowsToSkip ROWS ")
            sb.Append("FETCH NEXT @numberOfRows ROWS ONLY ")

            Return sb.ToString() 
        End Function 

        Public Shared Function GetSelectStatement() As String 
            Dim sb As New StringBuilder() 

            sb.Append("SELECT ") 
            sb.Append("[SaleAmount], ") 
            sb.Append("[OrderID], ") 
            sb.Append("[CompanyName], ") 
            sb.Append("[ShippedDate] ") 
            sb.Append("FROM [dbo].[Sales Totals by Amount] ") 

            Return sb.ToString() 
        End Function 
    End Class 
End Namespace 
